#!/usr/bin/perl
use strict;
#
# IPFire - dsl modem config 0.05
#
# This code is distributed under the terms of the GPL
#
# 28.08.2006 Arne Fitzenreiter
#

# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my %dslsettings=();
my $errormessage = '';
my $output = '';
my @filenames=();
my %checked=();

$dslsettings{'NEEDARP'}='';
$dslsettings{'PAGE1ON'}='';
$dslsettings{'PAGE2ON'}='';
$dslsettings{'PAGE3ON'}='';
$dslsettings{'PAGE4ON'}='';
$dslsettings{'PAGE5ON'}='';
$dslsettings{'PAGE6ON'}='';

&Header::showhttpheaders();

$dslsettings{'ACTION'} = '';
$dslsettings{'VALID'} = '';

&Header::getcgihash(\%dslsettings);

if ($dslsettings{'ACTION'} eq $Lang::tr{'save'})
{ 
        if (!($dslsettings{'TIMEOUT'} =~ /^\d+$/))
        {
      	 	$errormessage = 'timeout must be a number';
	 	goto ERROR;
        }

        if (!($dslsettings{'REFRESH'} =~ /^\d+$/))
        {
      	 	$errormessage = 'refresh must be a number';
	 	goto ERROR;
        }

ERROR:   
        if ($errormessage) {
                $dslsettings{'VALID'} = 'no'; }
        else {
                $dslsettings{'VALID'} = 'yes'; }

	$dslsettings{'FILENAME'}='';
	&General::writehash("${General::swroot}/dslmodem/active", \%dslsettings);
}



if ($dslsettings{'ACTION'} eq 'load')
{

	$dslsettings{'NEEDARP'}='';
	$dslsettings{'PAGE1ON'}='';
	$dslsettings{'PAGE2ON'}='';
	$dslsettings{'PAGE3ON'}='';
	$dslsettings{'PAGE4ON'}='';
	$dslsettings{'PAGE5ON'}='';
	$dslsettings{'PAGE6ON'}='';

	&General::readhash("${General::swroot}/dslmodem/$dslsettings{'FILENAME'}", \%dslsettings);
	&General::writehash("${General::swroot}/dslmodem/active", \%dslsettings);

}



&General::readhash("${General::swroot}/dslmodem/active", \%dslsettings);

$checked{'NEEDARP'}='';
if ($dslsettings{'NEEDARP'}) { $checked{'NEEDARP'} = "checked='checked'"; }

$checked{'PAGE1ON'}='';
if ($dslsettings{'PAGE1ON'}) { $checked{'PAGE1ON'} = "checked='checked'"; }

$checked{'PAGE2ON'}='';
if ($dslsettings{'PAGE2ON'}) { $checked{'PAGE2ON'} = "checked='checked'"; }

$checked{'PAGE3ON'}='';
if ($dslsettings{'PAGE3ON'}) { $checked{'PAGE3ON'} = "checked='checked'"; }

$checked{'PAGE4ON'}='';
if ($dslsettings{'PAGE4ON'}) { $checked{'PAGE4ON'} = "checked='checked'"; }

$checked{'PAGE5ON'}='';
if ($dslsettings{'PAGE5ON'}) { $checked{'PAGE5ON'} = "checked='checked'"; }

$checked{'PAGE6ON'}='';
if ($dslsettings{'PAGE6ON'}) { $checked{'PAGE6ON'} = "checked='checked'"; }

&Header::openpage('dsl modem configuration', 1, '');

&Header::openbigbox('100%', 'left', '', $errormessage);

if ($errormessage) {
	&Header::openbox('100%', 'left', $Lang::tr{'error messages'});
	print "<font class='base'>$errormessage&nbsp;</font>\n";
	&Header::closebox();
}


print "<form method='post' action='$ENV{'SCRIPT_NAME'}'>\n";

&Header::openbox('100%', 'left', 'dsl modem configuration :');
print <<END
<table width='100%'>
<tr>
	<td width='25%' class='base'>Modem Name:</td>
	<td width='25%' ><input type='text' name='NAME' value='$dslsettings{'NAME'}'></td>
       <td width='25%' class='base'>Modem IP Number:</td>
	<td width='25%' ><input type='text' name='IP' value='$dslsettings{'IP'}' /></td>
</tr>
<tr>
       <td class='base'>Modem Username:</td>
	<td><input type='text' name='USER' value='$dslsettings{'USER'}' /></td>
	<td class='base'>Modem Password:</td>
	<td><input type='password' name='PASS' value='$dslsettings{'PASS'}' /></td>
</tr>
</table>
<hr>
<table width='100%'>

<tr>
	<td width='25%' class='base'>My IP/Netmask/Broadcast:</td>
	<td width='25%' ><input type='text' name='MYIP' value='$dslsettings{'MYIP'}'></td>
	<td width='25%' ><input type='text' name='MYNETMASK' value='$dslsettings{'MYNETMASK'}'></td>
	<td width='25%' ><input type='text' name='MYBROADCAST' value='$dslsettings{'MYBROADCAST'}'></td>
</tr>
<tr>
       <td class='base'>Perm. ARP needed:</td>
	<td><input type='checkbox' name='NEEDARP' $checked{'NEEDARP'} /></td>
	<td class='base'>MAC/Serial:</td>
	<td><input type='text' name='ARP' value='$dslsettings{'ARP'}' /></td>
</tr>
</table>
<p align='center'>
This settings are only used for PPPOE connections. You have to reconnect before they are used!</p>
<hr>
<table width='100%'>
<tr>
       <td width='25%' class='base'></td>
       <td width='25%'class='base'>Name</td>
	<td width='45%'class='base'>Page</td>
	<td class='base'>On</td>
</tr>
<tr>
	<td  class='base'>Page1:</td>
       <td><input type='text' name='PAGE1NAME' value='$dslsettings{'PAGE1NAME'}' /></td>
       <td><input type='text' size='52' name='PAGE1' value='$dslsettings{'PAGE1'}' /></td>
       <td><input type='checkbox' name='PAGE1ON' $checked{'PAGE1ON'}></td>
</tr>
<tr>
	<td  class='base'>Page2:</td>
       <td><input type='text' name='PAGE2NAME' value='$dslsettings{'PAGE2NAME'}' /></td>
       <td><input type='text' size='52' name='PAGE2' value='$dslsettings{'PAGE2'}' /></td>
       <td><input type='checkbox' name='PAGE2ON' $checked{'PAGE2ON'}></td>
</tr>
<tr>
	<td  class='base'>Page3:</td>
       <td><input type='text' name='PAGE3NAME' value='$dslsettings{'PAGE3NAME'}' /></td>
       <td><input type='text' size='52' name='PAGE3' value='$dslsettings{'PAGE3'}' /></td>
       <td><input type='checkbox' name='PAGE3ON' $checked{'PAGE3ON'}></td>
</tr>
<tr>
	<td  class='base'>Page4:</td>
       <td><input type='text' name='PAGE4NAME' value='$dslsettings{'PAGE4NAME'}' /></td>
       <td><input type='text' size='52' name='PAGE4' value='$dslsettings{'PAGE4'}' /></td>
       <td><input type='checkbox' name='PAGE4ON' $checked{'PAGE4ON'}></td>
</tr>
<tr>
	<td  class='base'>Page5:</td>
       <td><input type='text' name='PAGE5NAME' value='$dslsettings{'PAGE5NAME'}' /></td>
       <td><input type='text' size='52' name='PAGE5' value='$dslsettings{'PAGE5'}' /></td>
       <td><input type='checkbox' name='PAGE5ON' $checked{'PAGE5ON'}></td>
</tr>
<tr>
	<td  class='base'>Page6:</td>
       <td><input type='text' name='PAGE6NAME' value='$dslsettings{'PAGE6NAME'}' /></td>
       <td><input type='text' size='52' name='PAGE6' value='$dslsettings{'PAGE6'}' /></td>
       <td><input type='checkbox' name='PAGE6ON' $checked{'PAGE6ON'}></td>
</tr>
</table>
<hr>
<table width='100%'>
<tr>
       <td width='25%' class='base'>timeout:</td>
	<td width='25%' ><input type='number' name='TIMEOUT' value='$dslsettings{'TIMEOUT'}' /></td>
	<td width='25%' class='base'>refreshtime:</td>
	<td width='25%' ><input type='number' name='REFRESH' value='$dslsettings{'REFRESH'}' /></td>
</tr>
</table>
<hr>
<table width='100%'>
<tr>
	<td align='center'>
		<input type='submit' name='ACTION' value='$Lang::tr{'save'}' />
	</td>
</tr>
<tr>
</tr>
</table>
</div>
END
;
&Header::closebox();

&Header::openbox('100%', 'left', 'preset dsl-modem configuration :');

	$output=`ls -1 ${General::swroot}/dslmodem/`;
	print "<p align='center'><select name='FILENAME'>";

	@filenames=split(' ',$output);
	for (@filenames) {print "<option value=$_>$_</option>";}
	
	print "</select> <input type='submit' name='ACTION' value='load'></p>";


&Header::closebox();
print "</form>\n";

&Header::closebigbox();

&Header::closepage();
